.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "3.01",
.\"     date            = "02 May 2000",
.\"     time            = "07:52:58 MDT",
.\"     filename        = "tgrind.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     checksum        = "48694 1296 5041 32917",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@computer.org, beebe@ieee.org (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "program listings, TeX, tgrind, typesetting,
.\"     		   vgrind",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual page
.\"			   documentation for tgrind, a program to
.\"			   produce nice program listings using TeX.
.\"
.\"			   This file is a considerable extension and
.\"			   revision of the original manual page file
.\"			   that accompanied version 1.0 of tgrind in
.\"			   1985.  The author of that release was Van
.\"			   Jacobson of Lawrence Berkeley Laboratory,
.\"			   who based his tgrind on vgrind, written by
.\"			   Dave Presotto and William Joy of UC
.\"			   Berkeley.
.\"
.\"			   The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.TH TGRIND 1 "02 May 2000" "Version 3.01"
.\"
.if t .ds Am A\\h'-0.1667m'\\v'0.20v'M\\v'-0.20v'\\h'-0.125m'S
.if n .ds Am AmS
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.if t .ds Ax \*(Am\*(Te
.if n .ds Ax AmSTeX
.\"
.if t .ds Bi B\s-2IB\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Bi BibTeX
.\"
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds La LaTeX
.\"
.if n .ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.if t .ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.\"
.\"=====================================================================
.SH NAME
tgrind \- typeset nice program listings using TeX
.\"=====================================================================
.SH SYNOPSIS
.B tgrind
[
.B \-?
]
[
.BI \-d " description-file"
]
[
.B \-f
]
.if n .ti +\w'\fBtgrind\fP\ 'u
[
.BI \-fn " fontfamily"
]
[
.BI \-h " header"
]
[
.BI \-i " increment"
]
.if n .ti +\w'\fBtgrind\fP\ 'u
[
.BI \-l " language"
]
.if t .ti +\w'\fBtgrind\fP\ 'u
[
.B \-n
]
[
.BI \-o " basename"
]
[
.B \-p
]
.if n .ti +\w'\fBtgrind\fP\ 'u
[
.B \-q
]
[
.B \-r
]
[
.B \-v
]
[
.B \-x
]
[
.B \-
]
filename ...
.\"=====================================================================
.SH DESCRIPTION
.B tgrind
formats program sources in a nice style using
.BR tex (1).
.PP
Comments are placed in italics, keywords in bold face and strings in
typewriter font.
.PP
Source file line numbers normally appear in the left margin every 10
lines.  but the numbering frequency, and side of the page, are under
user control.
.PP
The start of a function is indicated by the function name in large
type in the right margin.
.PP
.B tgrind
is
.I not
a prettyprinter: all line breaks and horizontal spacing in the input
source files are preserved.  Prettyprinters require more
sophistication, and language-specific knowledge, than is possessed by
.BR tgrind .
Consequently, you may find it useful to apply a prettyprinter to your
source code before giving it to
.BR tgrind .
Some of the available ones are:
.BR bibclean (1)
for \*(Bi\&,
.BR bstpretty (1)
for \*(Bi\& style language files,
.BR cb (1)
and
.BR indent (1)
for C and C++,
.BR pretty (1)
for Fortran,
.BR sf3pretty (1)
for Fortran and Sftran3,
.B indent-sexp
for GNU Emacs Lisp,
.BR mft (1)
for Metafont, and
.BR pform (1)
and
.BR pindent (1)
for Pascal.
.PP
In regular mode,
.B tgrind
processes its input file(s) and passes them to
.BR tex (1)
for formatting and output, and then sends the output to a DVI driver
for conversion to \*(Ps\&.
.PP
For privacy, all output files are normally left in the current
directory with numeric base names of the form
.IR tg_12345.tex ;
such names conform to the ISO 9660 standard for filenames on CD-ROMs
.RI ( "Volume and File Structure of CD-ROM for Information Interchange, ISO 9660:1988(E)" ),
for maximal portability across current operating systems.  The
.B \-o
option (see below) can change this behavior.
.B tgrind
will
.I not
overwrite existing files.
.PP
In format-only mode (i.e., when the
.B \-f
flag is used),
.B tgrind
processes its input file(s) and writes the result to standard output.
This output can be saved for later editing, inclusion in a larger
document, etc.
.PP
With version 3.00,
.B tgrind
has been redesigned so that its output is suitable for use with plain
\*(Te\&, as before, and also with major macro packages, such as
\*(Ax\& and \*(La\& 2.09 and 2e.
.PP
The output file can be typeset directly by plain \*(Te\& as a
stand-alone document, but it can also be \fC\einput\fP into an
\*(Ax\&, \*(La\&, or plain \*(Te\& document and typeset as a fragment
of the surrounding document.
.PP
To do this with \*(Ax\& and plain \*(Te\&, just use
.RS
.nf
\fC\elet \eEndTgrind = \eendgroup\fP
.fi
.RE
before including
.B tgrind
output; this replaces the default definition of that macro, which
would otherwise end the job.
.PP
For \*(La\& documents, the style file
.I tgrind.sty
provides suitable definitions, and can be used like this:
.TP \w'\*(La\&_2.09:'u+1n
\*(La\& 2.09:
.nf
\fC\edocumentstyle[tgrind]{...}\fP
.fi
.TP
\*(La\& 2e:
.nf
\fC\edocumentclass{...}\fP
\fC\eusepackage{tgrind}\fP
.fi
.PP
You may prefer to make a private modification of this style file and
save it under a different name.  The distributed version suppresses
the output of the \fC\eTgrindFile\fP macro, but a comment in the style
file shows how to make it invoke a sectional heading command instead.
Since the heading level chosen depends on the major document style or
class chosen, and also on the style of the particular document, there
is no reasonable heading level that could be used in a generic
.I tgrind.sty
file.
.\"=====================================================================
.SH OPTIONS
On IBM PC DOS and DEC (Open)VMS, the leading ``\-'' on option names may be
replaced by a slash, ``/''; however, the ``\-'' option prefix is
always recognized.
.PP
Option values are always provided as
.I separate
arguments following the option name.
.PP
Letter case in option names is
.I not
significant, although it may be in option values.
.PP
Any argument that begins with a hyphen is expected to be an option,
and will raise an error if it is not recognized.  If a filename begins
with a hyphen, you therefore need to disguise it by supplying a
leading directory path.  For example,
.IR ./\-foo
represents the file named
.I \-foo
in the current directory in UNIX.
.PP
The options are:
.TP
.B \-?
Display a brief usage summary on
.IR stderr ,
and exit immediately with a success return code.
.IP
This same usage summary is given when an unrecognized option is
encountered.
.TP
.BI \-d " description-file"
Specify the language definitions file (default is
.IR /usr/local/lib/tex/inputs/vgrindefs ).
This option is useful for testing new language definitions.
.TP
.B \-f
Force format-only mode.  This simply skips the \*(Te\& and DVI driver steps
and optional printer step, copies the temporary output \*(Te\& file to
.IR stdout ,
and deletes the temporary output \*(Te\& file.
.TP
.BI \-fn " fontfamily"
Define the font family to be used in the output.  The default font
family if this option is not specified is Computer Modern.  Otherwise,
all fonts are virtual fonts that map to \*(Ps\& Type 1 outline fonts,
making the \*(Ps\& output by a DVI driver more compact, and completely
resolution-independent (i.e., no character bitmaps).  The
.I fontfamily
values recognized may be given as a long font family name, or as a
short two- or three-letter font file prefix.  The family names
currently recognized are:
.RS
.TP \w'\(bu'u+2n
\(bu
.IR AvantGarde " (" pag ),
.TP
\(bu
.IR Bookman " (" pbk ),
.TP
\(bu
.IR Charter " (" bch ),
.TP
\(bu
.IR ComputerModern " (" cm ),
.TP
\(bu
.IR Courier " (" pcr ),
.TP
\(bu
.IR Helvetica " (" phv ),
.TP
\(bu
.IR HelveticaNarrow " (" phn ),
.TP
\(bu
.IR NewCentury " or " NewCenturySchoolbook " (" pnc ),
.TP
\(bu
.IR Palatino " (" ppl ),
.TP
\(bu
.IR Times " (" ptm ),
and
.TP
\(bu
.IR Utopia " (" put ).
.RE
.IP
All of these fonts, except
.I Charter
and
.IR Utopia ,
and sometimes,
.IR HelveticaNarrow ,
are resident in standard \*(Ps\& laser printers.  The exceptional
fonts will be included in the output \*(Ps\& by the DVI driver
program, if the driver's
.I psfonts.map
file correctly identifies them as non-resident fonts.
.IP
When this option is provided, the \*(Ps\& output will also use
.I Courier
for a typewriter font, and
.I Symbol
for certain special characters; both of these fonts are printer
resident.
.TP
.BI \-h " text"
Specify text to go on the left top margin of every output page
(default is none).
.TP
.BI \-i " increment"
Specify an alternate line number increment, overriding the default of
10.
.TP
.BI \-l " language"
Specify the language of the input file(s).  The
.I language
name often has two or three acceptable forms, one of which is the
standard source file extension in UNIX; see the bar-separated names
beginning each language entry in the
.I vgrindefs
file; these synonyms are excluded from the list below.  Here are the
.I language
names currently recognized:
.RS
.\"--------------------
.TP \w'\fBMiranda\fP'u+2n
.B a68
Motorola 68xxx assembly language.
.\"--------------------
.TP
.B ada
Ada.
.\"--------------------
.TP
.B asm68
Another Motorola 68xxx assembly language.
.\"--------------------
.TP
.B awk
.BR awk (1),
.BR gawk (1),
and
.BR nawk (1).
.\"--------------------
.TP
.B bash
GNU Bourne-Again shell
.RB ( bash (1)).
.\"--------------------
.TP
.B bibtex
\*(Bi\&
.RB ( bibtex (1)).
.\"--------------------
.TP
.B bst
\*(Bi\&
.RB ( bibtex (1))
style file language.
.\"--------------------
.TP
.B c
C (the default language).
.\"--------------------
.TP
.B caml
CAML.
.\"--------------------
.TP
.B c++
C++ and Objective C.
.\"--------------------
.TP
.B csh
C shell
.RB ( csh (1)).
.\"--------------------
.TP
.B ELisp
GNU Emacs Lisp.  Keywords are considered to be all of those low-level
Lisp functions that are implemented in the Lisp interpreter itself (in
the C programming language); higher-level Lisp functions written in
Lisp are not keywords.
.\"--------------------
.TP
.B f
Fortran.
.\"--------------------
.TP
.B i
ISP.
.\"--------------------
.TP
.B I
Icon.
.\"--------------------
.TP
.B ISP
Unknown language on NeXT systems.
.\"--------------------
.TP
.B ksh
Korn shell
.RB ( ksh (1)).
.\"--------------------
.TP
.B LDL
Unknown language.
.\"--------------------
.TP
.B latex
La\*(Te\& 2.09.  Keywords are considered to be all of the control
sequences named in the index of the first edition of Leslie Lamport,
.IR "La\*(Te\& User's Guide and Reference Manual" ,
Addison-Wesley (1985), ISBN 0-201-15790-X.  As with Emacs Lisp and
other extensible languages, it seems reasonable to distinguish
built-in `system' commands from `user' commands.
.\"--------------------
.TP
.B m
MODEL.
.\"--------------------
.TP
.B m2
Modula-2.
.\"--------------------
.TP
.B maple
Maple V.  Keywords include the language keywords, operators,
constants, and standard global variables.
.\"--------------------
.TP
.B maplex
Extended Maple V.  The keywords also include all of the
initially-loaded library functions.
.\"--------------------
.TP
.B matlab
Matlab.
.\"--------------------
.TP
.B Miranda
Miranda.
.\"--------------------
.TP
.B ml
MLisp and Emacs Lisp.
.\"--------------------
.TP
.B objc
Objective C.
.\"--------------------
.TP
.B p
Pascal.
.\"--------------------
.TP
.B prolog
Prolog.
.\"--------------------
.TP
.B ps
PostScript.
.\"--------------------
.TP
.B r
Ratfor.
.\"--------------------
.TP
.B russell
Russell.
.\"--------------------
.TP
.B sh
Bourne shell
.RB ( sh (1)).
.\"--------------------
.TP
.B sf3
Sftran3.
.\"--------------------
.TP
.B src
Unknown source code (no keywords, comments, or strings are
recognized).
.\"--------------------
.TP
.B tcl
Tool Command Language
.RB ( tcl (1)).
.\"--------------------
.TP
.B tcsh
Extended C shell
.RB ( tcsh (1)).
.\"--------------------
.TP
.B tex
\*(Te\&.
.\"--------------------
.TP
.B y
yacc.
.RE
.TP
.B \-n
Do not display keywords in boldface.
.IP
As a side effect, this option suppresses the marginal procedure
headers and thus also the index.  This may be changed in a future
version.
.TP
.BI \-o " basename"
Specify an alternate basename for the output files.  The default is
.IR tg_nnnnn ,
where
.I nnnnn
is obtained from the current time.  This option allows you to direct
the output files anywhere you like.  However,
.B tgrind
will still refuse to run if they already exist, in order to avoid
overwriting a possibly-important file.
.TP
.B \-p
Send the output \*(Ps\& to the default printer.
.TP
.B \-q
Quiet mode: suppress informational messages normally sent to
.I stderr
or
.IR stdout .
Error messages to
.I stderr
are never suppressed.
.TP
.B \-r
Print line numbers on the
.I right
instead of on the left.  Older versions of
.B tgrind
always numbered on the right, but this proved inconvenient because
numbers were sometimes overwritten by program text, and other times,
were so far from the text that it was difficult to match them
visually.  The new default of line numbering on the left eliminates
both of these problems.
.TP
.B \-v
Display the program version number and date on
.IR stderr ,
and exit immediately with a success return code.
.TP
.B \-x
Suppress the multicolumn index at the end of the program listing.
.TP
.B \-
Take input from standard input.
.\"=====================================================================
.SH BUGS
.PP
The marginal\-function\-name mechanism depends on the quality
of the language description in
.IR vgrindefs .
The distributed
.I vgrindefs
file fails to recognize many legal programming-language function
declarations.
.PP
The
.BR \-f ,
.BR \-o ,
and
.BR \-x
flags mean different things to
.B tgrind
and
.BR vgrind (1).
.\"=====================================================================
.SH "PORTABILITY ISSUES"
The table-driven preprocessor program,
.BR tfontedpr ,
is written in highly-portable C, and can be compiled with old (K&R)
style C compilers, as well as with ANSI/ISO Standard C and C++
compilers, and requires only a small number of universally-available
header files.  It compiles and runs on numerous UNIX systems, and
should be readily portable to other operating systems.  Its memory
requirements are modest: less than 100KB on typical UNIX systems.
.PP
.B tgrind
is a simple front-end to
.BR tfontedpr ,
which is rarely invoked directly by users.
.B tgrind
handles argument parsing, and invocation of the preprocessor, indexer,
\*(Te\&, DVI driver, and print spooler.
.PP
For portability,
.B tgrind
too is written in C, although the distribution also includes
implementations as UNIX
.BR sh (1)
and
.BR csh (1)
scripts.
.PP
Installation of both programs uses the GNU
.BR autoconf (1)
system for very simple one-line installation on any UNIX system.
.PP
The indexing program,
.IR tgrindex.awk ,
is written in
.BR nawk (1),
and can be readily handled by GNU
.BR gawk (1)
as well.  Commercial and freely-distributable implementations of these
languages are available for several personal computer operating
systems, and for DEC (Open)VMS.
.PP
Volunteers for ports of
.B tgrind
to other operating systems will be most welcome!
.\"=====================================================================
.SH "ADDING SUPPORT FOR NEW LANGUAGES"
The language translations implemented by
.B tgrind
are entirely table driven, using language descriptions given in the
.I vgrindefs
file, which is modeled after the colon-delimited
.I key=value
format of UNIX
.BR printcap (4)
and
.BR termcap (4)
capability files.  Adding support to
.B tgrind
for a new language requires only additions to this file.  Most
language entries average about 9 lines, of which 6 or 7 are usually
just enumerations of the language keywords.
.PP
Keys are either Boolean flags, in which case they take no
.I =value
string (the flag is set
.I true
if the key is present, and
.I false
if it is absent), or else string variables whose values are
specialized patterns, jokingly referred to as
.IR "irregular expressions" ,
vaguely similar to the regular expressions recognized by the UNIX
.BR ex (1)
editor and
.BR lex (1)
lexical-analyzer generator.
.PP
In
.B tgrind
patterns, the characters `$', `(', `)', `:', `?', `^', `|', and `\e'
are reserved characters: they must be quoted with a preceding \e if
they are to be interpreted as normal characters.  Otherwise, they have
these meanings:
.RS
.TP \w'xxxxx'u+2n
^
Beginning of line.
.TP
$
End of line.
.TP
:
Key-value capability pair delimiter.
.TP
\e
Escape character.  Two such characters, \e\e, represent a single
backslash.
.RE
The extended patterns are:
.RS
.TP \w'xxx'u+2n
\ea
Matches any number of characters (like `.*' in
.BR lex (1)).
.TP
\ed
Matches any number of whitespace delimiters (space, tab, newline,
start of line).
.TP
\ep
Matches any number of alphanumeric characters.  In a procedure
definition (the
.B pb
key), the string that matches this symbol is used as the procedure
name.
.TP
|
Alternation.
.TP
(\^)
Grouping, used mostly for alternation and optionality.
.TP
?
Last item is optional (i.e., occurs zero times, or one time).
.TP
\e
Preceding any string means that the string will not match an input
string if the input string is preceded by an escape character (\e).
This is typically used for languages (like C) that can include the
string delimiter in a string by escaping it.
.RE
.PP
Unlike other implementations of regular expressions, these patterns
match
.I words
and not characters.  Hence something like
.I (foo\^|\^bar)mumble?
would match
.IR foo ,
.IR bar ,
.IR foomumble ,
or
.IR barmumble .
In
.B tgrind
patterns, alternation binds very tightly, so grouping parentheses are
likely to be necessary in expressions involving alternation.
.PP
Here are the capability keys that are currently used in the
.I vgrindefs
file, and in the source code file,
.IR tfontedpr.c :
.RS
.TP
.B ab
Alternate comment begin.
.TP
.B ae
Alternate comment end.
.TP
.B bb
Begin statement block.
.TP
.B be
End statement block.
.TP
.B cb
Comment begin.
.TP
.B ce
Comment end.
.TP
.B ic
Define extra characters that may appear as initial characters of
procedure names (those that match
.IR \ep )
and keywords, beyond the hard-wired defaults of letters, digits, and
underscore.  This supports languages that place restrictions on the
initial characters of identifiers.  If this key is not provided, then
initial characters are treated the same as non-initial characters.
This key does not exist in
.BR vgrind (1)
implementations.
.TP
.B id
Define extra characters that may appear in procedure names (those that
match
.IR \ep )
and keywords, beyond the hard-wired defaults of letters, digits, and
underscore.  This supports languages, like Lisp and \*(Te\&, that have
a more extensive character set for identifiers.  This key does not
exist in older
.BR vgrind (1)
implementations; it may have been introduced first by Sun Microsystems
in the Solaris 2.x operating system release.
.TP
.B kw
Language keywords (a space-separated list, usually in alphabetical
order for readability, though that is not a requirement).
.TP
.B lb
Literal string begin.
.TP
.B le
Literal string end.
.TP
.B nc
Define characters that may
.I not
appear as initial characters of procedure names (those that match
.IR \ep )
and keywords.  This provides a way to remove initial identifier
characters from the hard-wired defaults of letters, digits, and
underscore.  Its value is examined
.I after
any
.B ic
value.  This key is
.I not
available in
.BR vgrind (1).
.TP
.B ni
Define characters that may
.I not
appear in procedure names (those that match
.IR \ep )
and keywords.  This provides a way to remove identifier characters
from the hard-wired defaults of letters, digits, and underscore.  Its
value is examined
.I after
any
.B id
value.  This key is unique to
.BR tgrind ;
it is
.I not
available in
.BR vgrind (1).
.TP
.B oc
(Boolean) one case flag: letter case is not significant.
.TP
.B pb
Procedure (function, subroutine) begin.
.TP
.B sb
Character string begin.
.TP
.B se
Character string end.
.TP
.B tc
If this key appears, it
.I must
be last.  Its value is the name of another
.I vgrindefs
entry that is looked up and appended to the end of the current entry,
minus the initial entry names.  That entry in turn may end with a
.B tc
key that refers to yet another entry, and so on, up to a limit of 32
(to catch unterminating loops).  If the same key appears more than
once in the constructed entry, only the first value is used.  Thus,
.B tc
can be used to prepare minor variations on a basic language definition.
.TP
.B tl
(Boolean) top lex flag: procedures may be defined only at top level,
that is, nested procedures are
.I not
permitted.
.RE
.PP
The string value of
.B id
and
.B kw
is treated as an ordinary string, rather than a pattern:
backslash has significance only at end-of-line, or before a colon.
.PP
Keys are always exactly two characters long, and the equals sign that
separates them from their values must follow immediately, without
intervening whitespace.
.PP
If you need a single backslash in a string, represent it like this:
.BR :id=\e\e: .
.BR vgrind (1),
and older versions of
.BR tgrind ,
do not permit this, because their simplistic scan assumes that
backslash-colon does not terminate the string.  Alternatively, since
backslash is significant only before colon and newline in
.B id
and
.B ni
strings, you could also write
.BR :id=\ea: ,
since `a' is already in the identifier character set.
.PP
Let's dissect a typical entry to see how this works:
.PP
.nf
\fCmodula2|mod2|m2:\e
        :pb=(^\ed?(procedure|function|module)\ed\ep\ed|\e(|;|\e:):\e
        :bb=\ed(begin|case|for|if|loop|record|repeat|while|with)\ed:\e
        :be=\edend|;:\e
        :cb={:\e
        :ce=}:\e
        :ab=\e(*:\e
        :ae=*\e):\e
        :sb=":\e
        :se=":\e
        :oc:\e
        :kw=and array begin by case const definition div \e
        do else elsif end exit export for from if \e
        implementation import in loop mod module not of \e
        or pointer procedure qualified record repeat \e
        return set then to type until var while with:\fP
.fi
.PP
Each line after the first conventionally begins with a tab, although
this is not required, and if the next character is a colon, a key name
follows.  Terminal backslashes indicate line continuation.
.PP
Multiple \fIkey=value\fP pairs can be given on one line, as long as
they are separated by colons, so at the loss of readability, we could
compact seven lines of this entry into just one, like this:
.PP
.nf
        \fC:cb={:ce=}:ab=\e(*:ae=*\e):sb=":se=":oc:\e\fP
.fi
.PP
The first line in our sample entry says that this language may be
named \fCmodula2\fP, \fCmod2\fP, or \fCm2\fP in the
.B tgrind
.B \-l
option.
.PP
The \fCpb\fP line says that a procedure definition begins a line with
optional whitespace, followed by one of the keywords \fCprocedure\fP,
\fCfunction\fP, or \fCmodule\fP, followed by optional whitespace,
followed by an alphanumeric procedure name.  That name in turn may be
followed by whitespace, an open parenthesis, a semicolon, or a colon,
thanks to the tight binding of alternation. It would have been clearer
to include grouping parentheses, writing \fC(\ed|\e(|;|\e:)\fP.
.PP
The \fCbb\fP line says that a statement block starts with optional
whitespace, and one of the keywords \fCbegin \|.\|.\|. with\fP, and
the \fCbe\fP line says a statement block ends with optional
whitespace, followed by either the keyword \fCend\fP, or a semicolon.
.PP
The \fCcb\fP and \fCce\fP lines say that comments are delimited by
braces, and the \fCab\fP and \fCae\fP lines say that comments may also
be delimited by \fC(* *)\fP.
.PP
The \fCsb\fP and \fCse\fP lines say that strings are delimited by
quotation marks.
.PP
The \fCoc\fP flag says that letter case is not significant in names;
this seems to be in error: Niklaus Wirth's
.IR "Programming in Modula-2" ,
Springer-Verlag (1983), ISBN 0-387-12206-0, says that upper and lower
case letters are distinct.
.PP
Finally, the \fCkw\fP lines enumerate all of the Modula-2 language
keywords, from \fCand\fP to \fCwith\fP.
.\"=====================================================================
.SH "ADDING SUPPORT FOR NEW FONTS"
Any
.B \-fn
font name specified on the
.B tgrind
command line is written directly to the beginning of the output
\*(Te\& file in the form
.RS
.nf
\fC\edef \eTgrindFontFamily {NewCenturySchoolbook}\fP
.fi
.RE
followed by the lines
.RS
.nf
\fC\eifx \eBeginTgrind \eundefined
  \einput tgrindmac
\efi\fP
.fi
.RE
The interpretation of the font family name is handled entirely in the
\*(Te\& file,
.IR tgrindmac.tex .
For this example, a line in that file says
.RS
.nf
.nh
\fC\eifstreq{\eTgrindFontFamily}{NewCenturySchoolbook}
\edef \eTgrindFontFamily {pnc}\efi\fP
.hy
.fi
.RE
This replaces the definition of \fC\eTgrindFontFamily\fP with
.IR pnc .
A few lines later, we find
.RS
.na
.nh
\fC\eifstreq{\eTgrindFontFamily}{pnc} \esetfonts pnc r ri b.\efi\fP
.hy
.ad
.RE
When \fC\eTgrindFontFamily\fP has the value
.IR pnc ,
\fC\esetfonts\fP
is executed with four arguments: the basename of the virtual font, and
the suffixes to be added to it to name upright, italic, and bold
fonts.
.PP
Thus, \*(Te\& will expect to find in its
.I TEXFONTS
search path the \*(Te\& font metric files
.IR pncr.tfm ,
.IR pncri.tfm ,
and
.IR pncb.tfm ,
and the DVI driver will expect to find in the same search path the
virtual font files
.IR pncr.vf ,
.IR pncri.vf ,
and
.IR pncb.vf .
.PP
Besides these files, \fC\esetfonts\fP will generate references to
fonts
.I pcrro
and
.I psyr
for typewriter text and special symbols, so \*(Te\& will also need
.I pcrro.tfm
and
.IR psyr.tfm ,
and the DVI driver will need
.I pcrro.vf
and
.IR psyr.vf .
.PP
If all of the referenced fonts exist on the system, \*(Te\& and the
DVI driver will handle the rest of the job automatically, and if you
added two lines similar to the ones above to a private copy of
.IR tgrindmac.tex
to define a new font family, you can stop reading this section now.
.PP
However, here's what goes on behind the scenes.  The virtual font
files contain references to the so-called `raw' \*(Te\& font metric
files, prefixed by a letter `r', in this case,
.IR rpcrro.tfm
and
.IR rpsyr.tfm .
The correspondence between these raw font metric files and the actual
long \*(Ps\& font names, such as
.I Courier-Oblique
and
.IR Symbol ,
is made in the
.I psfonts.map
file, with lines like these:
.RS
.nf
\fCrpcrro  Courier-Oblique
rpsyr   Symbol
\&.\|.\|.
rptmro  Times-Roman ".167 SlantFont"
\&.\|.\|.
putb0   Utopia-Bold <putb0.pfb
putbo0  Utopia-Bold ".167 SlantFont " <putb0.pfb\fP
.fi
.RE
The first two simply identify the mapping between a file name and a
font name.  The third additionally specifies that the Times-Roman font
is to be slanted to the right by one-sixth, to synthesize an oblique
Times-Roman.  The fourth tells the DVI driver that the font definition
must be downloaded from the
.I putb0.pfb
Type 1 \*(Ps\& binary font file, and the fifth specifies both a slant
and a source file to be downloaded.
.\"=====================================================================
.SH "FONTS REQUIRED"
In the absence of the
.B \-fn
option,
.B tgrind
produces output that requires only fonts that are standardly preloaded
in plain \*(Te\&, so that the output files can be typeset by any
\*(Te\& installation.  Specifically, the default fonts used are:
.RS
.TS
tab(&);
l l .
cmr7                        &% margin line numbers
cmb10
cmti10
cmr10
cmsy10
cmtt10
cmbx10 scaled \emagstep1    &% page headers
cmr10 scaled \emagstep2     &% right margin proc names
.TE
.RE
.PP
Larger font sizes than the default 10pt sizes are usually undesirable
for program listings, because their lines are already often rather
long for normal typesetting conventions.
.PP
When a \*(Ps\& font is specified, the sizes called for are
.RS
.TS
tab(&);
l l l.
\fIroman\fP     &at  7pt    &% margin line numbers
\fIbold\fP      &at 10pt
\fIitalic\fP    &at 10pt
\fIroman\fP     &at 10pt
Symbol          &at 10pt
Courier-Oblique &at 10pt
\fIbold\fP      &at 12pt    &% page headers
\fIroman\fP     &at 14pt    &% right margin proc names
.TE
.RE
.PP
The exact names for the \fIbold\fP, \fIitalic\fP, and \fIroman\fP
variants depend on the font chosen; the calls to the \fC\esetfont\fP
macro in
.I tgrindmac.tex
encode this information.
.\"=====================================================================
.SH FILES
NB: The names of the default installation directories shown below can
be changed at installation time, and may be different at your site.
.TP \w'\fItgrindmac.tex\fP'u+2n
.I tg_nnnnn.*
default temporary files, where
.I nnnnn
is a generated number
.TP
.I /usr/local/lib/tex/inputs/multicol.tex
multi-column plain \*(Te\& macro package
.TP
.I /usr/local/lib/tex/inputs/psfonts.map
DVI driver \*(Ps\& font mapping file
.TP
.I /usr/local/lib/tex/inputs/tgrindex.awk
indexing program
.TP
.I /usr/local/lib/tex/inputs/tgrindex.tex
indexing macro package
.TP
.I /usr/local/lib/tex/inputs/tgrindmac.tex
.B tgrind
macro package
.TP
.I /usr/local/bin/tgrind
user-callable
.B tgrind
program
.TP
.I /usr/local/bin/tfontedpr
.B tgrind
preprocessor program
.TP
.I /usr/local/lib/tex/inputs/vgrindefs
language descriptions
.\"=====================================================================
.SH AUTHOR
Van Jacobson, Lawrence Berkeley Laboratory (based on
.BR vgrind (1)
by Dave Presotto and William Joy of UC Berkeley).
.PP
Extensions for \*(Ps\& fonts, procedure indexing,
space after the
.B \-l
option, the
.B \-o
option,
the
.BR ic ,
.BR id ,
.BR nc ,
and
.B ni
keywords, language support for Ada, awk, bash, \*(Bi\&, \*(Bi\&
style file language, ANSI/ISO Standard C, ANSI/ISO Standard C++, CAML,
ELisp, Fortran, ksh, La\*(Te\&, Maple, Matlab, MLisp, Miranda,
Objective C, PostScript, Russell, Sftran3, and tcsh, plus major
revisions of documentation and source distribution, by
.RS
.nf
Nelson H. F. Beebe
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
FAX: +1 801 585 1640, +1 801 581 4148
Tel: +1 801 581 5254
.fi
.RE
.\"=====================================================================
.SH AVAILABILITY
.B tgrind
is freely distributable. The definitive master archive at the
maintainer's site is available at
.RS
.nf
\fChttp://www.math.utah.edu/pub/tex/bib/index-table-t.html#tgrind\fP
\fCftp://ftp.math.utah.edu/pub/tex/bib/tgrind-\fP\fIx.y\fP\fC.tar.gz\fP
.fi
.RE
where \fIx.y\fP is a version number (3.01 for this release)
.PP
You should also be able to find the most recent version in the
Comprehensive \*(Te\& Archive Network (CTAN) collections; for a list
of CTAN hosts, do
.RS
.nf
\fCfinger ctan@tug.org\fP
.fi
.RE
The three main CTAN master sites at the time of writing are:
.RS
.nf
\fCftp.dante.de\fP (Germany)
\fCftp.tex.ac.uk\fP (England)
\fCctan.tug.org\fP (Massachusetts, USA)
.fi
.RE
.\"=====================================================================
.SH "SEE ALSO"
.BR autoconf (1)
.BR awk (1),
.BR bash (1),
.BR bibclean (1),
.BR bibtex (1),
.BR bstpretty (1),
.BR cb (1),
.BR csh (1),
.BR dpsexec (1),
.BR ex (1),
.BR gawk (1),
.BR gs (1),
.BR indent (1),
.BR ksh (1),
.BR lex (1),
.BR maple (1),
.BR matlab (1),
.BR mft (1),
.BR nawk (1),
.BR pageview (1),
.BR pform (1),
.BR pindent (1),
.BR postscript (1),
.BR pretty (1),
.BR printcap (4),
.BR sf3pretty (1),
.BR sh (1),
.BR tcsh (1),
.BR termcap (4),
.BR tex (1),
.BR vgrind (1),
.BR vgrindefs (5),
.BR xmaple (1),
.BR xsf3 (1).
.\"==============================[The End]==============================
